<infoview>
    <style>
        .info-top {
            margin-top: 30px;
        }
        .update-btn {
            margin-right: 15px
        }
        /*table tr td:first-child {*/
        /*    width: 90px;*/
        /*}*/
        /*table tr td:nth-child(3) {*/
        /*    width: 80px;*/
        /*}*/
        textarea {
            width: 100%;
        }
        #input-end {
            width: 110px;
        }
    </style>
    <div class="info-top">
        <table class="table table-striped">
            <tr>
                <td>利用者名:</td>
                <td>{ assetData.userName }</td>
                <td>利用期間:</td>
                <td>
                    <span>{ assetData.start }〜</span>
                    <span id="label-end" class="{isShow ? 'hide' : ''}" onclick="{ onEndClick }">{ assetData.end }</span>
                    <input type="text" id="input-end" name="input-end" class="datepicker {isShow ? '' : 'hide' }" value="{assetData.end }"/>
                </td>
            </tr>
            <tr>
                <td>バージョン:</td>
                <td>{ getVersion(assetData.pro) }</td>
                <td>機種:</td>
                <td>{ assetData.kindType}</td>
            </tr>
            <tr>
                <td>電話番号:</td>
                <td>{assetData.contactTel}</td>
                <td>注文番号:</td>
                <td>{assetData.orderNo}</td>
            </tr>
            <tr aria-colspan="2">
                <td>備考:</td>
                <td colspan="3">
                    <textarea id="memo" name="memo" rows="5">{assetData.memo}</textarea>
                </td>
            </tr>
        </table>
        <div class="update-btn pull-right">
            <button onclick="{ onSubmitClick }" class="bdt-button buttons-create btn btn-nc">更新</button>
        </div>
    </div>
    <script>
        export default {
            async onBeforeMount(props, state) {
                moment.locale('ja')
                this.assetData = {}
                this.assetService = new AssetService()
                this.assetId = props.assetId
                this.isShow = false
                var response = await this.assetService.get(this.assetId)
                this.assetData = response.data[0]
                this.update()
            },
            onMounted(props, state) {
                var self = this
                $('.datepicker').on('focusout', function (){
                    self.isShow = false
                    self.update()
                })

                $('.datepicker').datetimepicker({
                    dayViewHeaderFormat: 'YYYY年MM月',
                    format : 'YYYY-MM-DD',
                    inline: false,
                    locale: 'ja'
                }).on('dp.change', async function (e) {
                    var oldDate = e.oldDate ? e.oldDate.format('YYYY-MM-DD') : ''
                    if (!oldDate) {
                        return
                    }

                    var date = e.date.format('YYYY-MM-DD')

                    if (oldDate == date) {
                        return
                    }

                    self.assetData.end = date

                    // 端末管理の場合
                    if ($('#asset_datatables').length > 0) {
                        var editor = $('#asset_datatables').DataTable().editor()
                        var index = $('#asset_datatables').DataTable().data().toArray().findIndex(function (item) { return item.assetId == self.assetId})
                        editor.edit(index,false).set('end',date).submit()
                    } else {
                        // お問い合わせ管理の場合
                        var response = await self.assetService.update(self.assetData)
                        if (response.statusCode != 200) {
                            toastr.error(response.message)
                            return
                        }
                    }
                    self.isShow = false
                    self.update()
                }).on('dp.hide', async function (e) {
                    self.isShow = false
                    self.update()
                });

                this.update()
            },
            async onSubmitClick() {
                var self = this
                var memo = $('#memo').val()

                // 端末管理の場合
                if ($('#asset_datatables').length > 0) {
                    var editor = $('#asset_datatables').DataTable().editor()
                    var index = $('#asset_datatables').DataTable().data().toArray().findIndex(function (item) { return item.assetId == self.assetId})
                    editor.edit(index,false).set('memo',memo).submit()
                } else {
                    // お問い合わせ管理の場合
                    self.assetData.memo = memo
                    var response = await self.assetService.update(self.assetData)
                    if (response.statusCode != 200) {
                        toastr.error(response.message)
                        return
                    }
                }
                toastr.success('備考を更新しました。')
            },
            getVersion(pro) {
                if (pro == 0) {
                    return 'ライト版'
                }
                return 'プロ版'
            },
            onEndClick(e) {
                this.isShow = true
                this.update()
                $('.datepicker').focus()
            }
        }
    </script>
</infoview>